/**
 * Created by stts on 16.12.16.
 */
const http = require("http");
const url = require("url");
const server = http.createServer();
const humiditySensor = require("@tibbo-tps/tibbit-30").init("S5");
const fs = require('fs');
const port = 3000;
const reqUrl = "/imei.json";
var imeis={
    s1:'',
    s5:'',
    s13:'',
    s09:''
};

var SerialPort = require("serialport");
var exec=require('child_process').exec;

var imeiFunc=(s)=>{
    return new Promise((resolve,reject)=>{
        console.log(s);

        var sock = {
            'S17':'O0',
            'S1': 'O1',
            'S5': 'O3',
            'S13':'O4',
            'S9': 'O5'
        };
        var sockPlus = {
            'S17':'S19',
            'S1': 'S3',
            'S5': 'S7',
            'S13':'S15',
            'S9': 'S11'
        };
        fs.exists("/dev/tty"+sock[s.toUpperCase()],(exist)=>{
            if(exist){
                exec('/etc/ppp/peers/T_reset.sh tty'+sock[s.toUpperCase()] +' '+sockPlus[s.toUpperCase()],(err,stdout,stderr)=>{
                    if(err){
                        console.log(err);
                        reject()
                    }else{

                        var port = new SerialPort("/dev/tty"+sock[s.toUpperCase()], {
                            baudRate: 115200
                        });
                        port.on('open',(err)=>{
                            port.write('AT+GSN\r\n',(err)=>{
                                if(err){
                                    console.log(err);
                                }
                            });
                        });
                        port.on('data',(data)=>{
                            var str=data.toString('utf8');
                            str=str.replace(/\r/g,'');
                            str=str.split('\n');
                            if(/[0-9]+/ig.test(str[2])){
                                //imeis[s]=str[2];
                                port.close();
                                resolve(str[2]);
                                console.log(str[2]);
                            }else{
                                reject()
                            }
                        });
                    }
                });
            } else{
                console.log('sock not found');
                reject();
            }
        });

    });
};

server
    .on("request", (req, res) => {
        var urlParts=url.parse(req.url,true);
        // console.log(urlParts);
        if (urlParts.pathname === reqUrl) {
            // console.log(req);
            var query=urlParts.query;
            res.setHeader('Content-Type', 'application/json; charset=utf-8');
            if(query.s!==undefined){
                if(query.s in imeis){
                    if(imeis[query.s].length>0){
                        console.log('from arr');
                        res.end(JSON.stringify({imei:imeis[query.s]}));
                    }else{
                        console.log("not in array");
                        imeiFunc(query.s)
                            .then((result)=>{
                                // console.log(res);
                                imeis[query.s]=result;
                                var start = process.hrtime();
                                // console.log('to function');
                                res.end(JSON.stringify({'err':null,'imei':result}), function (){
                                    // console.log(process.hrtime(start));
                                });
                            })
                            .catch(function (err) {
                                console.log(err);
                                res.end(JSON.stringify({'err':'no such file'}), function (){
                                    // console.log(process.hrtime(start));
                                });
                            })

                    }
                }

            }

        }
        else {
            res.statusCode = 404;
            res.end();
        }
    })
    .listen(port, () => {
        console.log("LISTENING ON: " + port)
    })
;