/**
 * Created by stts on 06.10.16.
 */
var fs= require('fs');
var soft={
    'tios':'/opt/tps-tios/sbin/ltios',
    'aggregateServer':'/opt/AggreGate',
    'aggregate':['/opt/AggreGate','/opt/tpsagent'],
    'aggregateAgent':'/opt/tpsagent',
    'tibbitsLayout':'/var/www/tps-wan/site/root/mod-www-builder'
};
var tibbits={};
var getMenu=function(menuArr){
    return new Promise(function(resolve,reject){
        var promises=[];
        menuArr.forEach(function(item,index){
            if(item.check=='true'){
                promises[index]=check({name:item.id,type:'soft'});
            }
        });
        Promise.all(promises).then(function(items){
            var resMenu=menuArr.map(function(item){
                return item;
            }).filter(function(item,index){
                if(item.check=='true'){
                    return items[index];
                    // return false;
                }else{
                    return true;
                }
            });
            console.log(resMenu);
            resolve(resMenu);
        });
    });

};
var getBackupList=function(menuArr){
    return new Promise(function(resolve,reject){
        var promises=[];
        menuArr.forEach(function(item,index){
            if(item.check=='true'){
                promises[index]=check({name:item.name,type:'soft'});
            }
        });
        Promise.all(promises).then(function(items){
            var resMenu=menuArr.map(function(item){
                return item;
            }).filter(function(item,index){
                if(item.check=='true'){
                    return items[index];
                    // return false;
                }else{
                    return true;
                }
            });
            resolve(resMenu);
        });
    });
};
var check=function (obj) {
    return new Promise(function(resolve,reject){
        switch (obj.type){
            case 'soft':
                // console.log(soft[obj.name]);
                // console.log(obj);
                if(Array.isArray(soft[obj.name])){
                    let tmpResEx=false;
                    soft[obj.name].forEach((item)=>{
                        let exist=fs.existsSync(item);
                        if(exist){
                            tmpResEx=exist;
                        }
                        // resolve(exist)
                    });
                    resolve(tmpResEx);
                }else{
                    fs.exists(soft[obj.name],function(exist){
                        // console.log(obj.name, exist);
                        resolve(exist)
                    });
                }

                break;
        }
    });

};
module.exports={
    check:check,
    getMenu:getMenu,
    getBackupList:getBackupList
};