/**
 * Created by stts on 07.10.16.
 */
const http = require("http");
const server = http.createServer();
const humiditySensor = require("@tibbo-tps/tibbit-30").init("S5");
const fs = require('fs');
const port = 3000;
const url = "/data.json";
var find=0;
var data={};
var scan=setInterval(function () {
    var dir = fs.readdirSync('/tmp');
    var reg = /S\d+_imei/g;
    var fileReg=/\d+/g;
    dir.forEach((item)=> {
        if (reg.test(item)) {
            var file=fs.readFileSync('/tmp/'+item,'utf8');
            var res=fileReg.exec(file);

            data[item.replace('_','').toUpperCase()]=res[0];
            find++;
        }
    });
    if(find>0){
        clearInterval(scan)
    }

}, 5000);
setInterval(function () {
    var tmpData = humiditySensor.getData();
    data.temp=tmpData.temperature;
    data.hum=tmpData.humidity;
    console.log(data)
}, 10000);
server
    .on("request", (req, res) => {
        if (req.url === url
        ) {
            res.setHeader('Content-Type', 'application/json; charset=utf-8');
            res.end(JSON.stringify(data));
        }
        else {
            res.statusCode = 404;
            res.end();
        }
    })
    .listen(port, () => {
        console.log("LISTENING ON: " + port)
    })
;