/**
 * Created by stts on 06.04.2016.aaaaaa
 */
const net = require('net');
var valid = require(__dirname + '/modules/valid');
var fs = require('fs');
var _ = require('underscore');
var exist=fs.existsSync('/var/run/wan.sock');
if(exist){
    fs.unlink('/var/run/wan.sock');
}

const server = net.createServer(function (c) {
    console.log('client connected');
    c.on('end', function () {
        console.log('client disconnected');
    });
    c.on('data', function (data) {

        res=valid.valid(data.toString());
        res=_.uniq(res);
        if(res.length>0){
            var str=res.map(function(item){
                return 'WRN[]='+item;
            }).join('\n');
        }else{
            str='INF[]= validation successful!'
        }
        c.write(str);
        console.log(res);
        c.end();
    });
    c.on('error', function (err) {
        console.log(err);
    });
});
server.on('close', function () {
    console.log('server close');
});
server.listen('/var/run/wan.sock', function () {
    console.log('server bound');
});
